"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var _scrollViewModule = require('ui/scroll-view');
var _view = require('ui/core/view');
var _stackLayout = require('ui/layouts/stack-layout');
var ParallaxViewCommon = (function (_super) {
    __extends(ParallaxViewCommon, _super);
    function ParallaxViewCommon() {
        var _this = this;
        _super.call(this);
        var headerView;
        var scrollView;
        var viewsToFade;
        var maxTopViewHeight;
        var controlsToFade;
        var wrapperStackLayout = new _stackLayout.StackLayout();
        this._addChildFromBuilder = function (name, value) {
            if (value instanceof _view.View) {
                if (_this.content == null) {
                    _this.content = wrapperStackLayout;
                }
                wrapperStackLayout.addChild(value);
            }
        };
        viewsToFade = [];
        scrollView = this;
        scrollView.on(_scrollViewModule.ScrollView.loadedEvent, function (data) {
            if (controlsToFade == null && _this.controlsToFade == null) {
                controlsToFade = [];
            }
            else {
                controlsToFade = _this.controlsToFade.split(',');
            }
            var prevOffset = -10;
            var topOpacity = 1;
            headerView = wrapperStackLayout.getChildAt(0);
            maxTopViewHeight = headerView.height;
            controlsToFade.forEach(function (id) {
                var newView = wrapperStackLayout.getViewById(id);
                if (newView != null) {
                    viewsToFade.push(newView);
                }
            });
            if (headerView == null) {
                return;
            }
            headerView.height = maxTopViewHeight;
            scrollView.on(_scrollViewModule.ScrollView.scrollEvent, function (args) {
                if (prevOffset <= scrollView.verticalOffset) {
                    if (headerView.height >= 0) {
                        headerView.height = _this.getTopViewHeight(maxTopViewHeight, scrollView.verticalOffset);
                    }
                }
                else {
                    if (headerView.height <= maxTopViewHeight) {
                        headerView.height = _this.getTopViewHeight(maxTopViewHeight, scrollView.verticalOffset);
                    }
                }
                if (scrollView.verticalOffset < maxTopViewHeight) {
                    topOpacity = parseFloat((1 - (scrollView.verticalOffset * 0.01)).toString());
                    if (topOpacity > 0 && topOpacity <= 1) {
                        viewsToFade.forEach(function (view) {
                            view.opacity = topOpacity;
                        });
                    }
                }
                prevOffset = scrollView.verticalOffset;
            });
        });
    }
    Object.defineProperty(ParallaxViewCommon.prototype, "controlsToFade", {
        get: function () {
            return this._controlsToFade;
        },
        set: function (value) {
            this._controlsToFade = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ParallaxViewCommon.prototype, "android", {
        get: function () {
            return;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ParallaxViewCommon.prototype, "ios", {
        get: function () {
            return;
        },
        enumerable: true,
        configurable: true
    });
    ParallaxViewCommon.prototype.getTopViewHeight = function (topHeight, verticalOffset) {
        if ((topHeight - verticalOffset) >= 0) {
            return topHeight - verticalOffset;
        }
        else {
            return 0;
        }
    };
    return ParallaxViewCommon;
}(_scrollViewModule.ScrollView));
exports.ParallaxViewCommon = ParallaxViewCommon;
//# sourceMappingURL=nativescript-parallax.common.js.map